#include <libthrowable.h>
#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace libthrowable;
using namespace std;
namespace {
void thisFunctionMayFail()
{
	unsigned val = rand()%8;
	if(val == 0)
		throw Error(LIBTHROWABLE_HERE, "fatal error dected");
	else if(val == 1)
		throw Problem(LIBTHROWABLE_HERE, "a problem has occured");
	else if(val == 2)
		throw Exception(LIBTHROWABLE_HERE, "val == 2");
}
}

int main()
{
	srand(time(NULL));
	for(unsigned i=0; i != 8; ++i)
	{
		try
		{
			thisFunctionMayFail();
		}
		catch(const Throwable& th)
		{
			cerr << "** Throwable caught in main():" << endl;
			cerr << th << endl;
		}
	}
}
